package cn.com.qmth.examcloud.core.oe.student.service.impl;

import cn.com.qmth.examcloud.core.oe.student.service.ExamingSessionService;
import cn.com.qmth.examcloud.support.examing.ExamingSession;
import cn.com.qmth.examcloud.web.redis.RedisClient;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;

/**
 * @author chenken
 * @date 2018/8/15 9:24
 * @company QMTH
 * @description 考试会话服务实现
 */
@Service("examingSessionService")
public class ExamingSessionServiceImpl implements ExamingSessionService {

    @Autowired
    private RedisClient redisClient;
    
    @Value("${exam_redis_key_prefix}")
    private String examRedisKeyPrefix;

    private static final Logger log = LoggerFactory.getLogger(ExamControlServiceImpl.class);

    @Override
    public void saveExamingSession(Long studentId, ExamingSession examingSession, int timeout) {
        log.debug("11.4.1 进入开始保存考试会话方法，redisKey="+examRedisKeyPrefix+studentId);
        redisClient.set(examRedisKeyPrefix+studentId,examingSession,timeout);
        ExamingSession sessionInfo =redisClient.get(examRedisKeyPrefix+studentId,ExamingSession.class);
        log.debug("11.4.2 保存考试会话方法完成"+sessionInfo.getExamStudentId());
    }

    @Override
    public ExamingSession getExamingSession(Long studentId) {
        return redisClient.get(examRedisKeyPrefix+studentId,ExamingSession.class);
    }

    @Override
    public void deleteExamingSession(Long studentId) {
        redisClient.delete(examRedisKeyPrefix+studentId);
    }
}
